/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var AnyToAny = function()
{
	
	var a2a = {};
	
	/**
		Initialize the page.
	*/
	a2a.initPage = function()
	{
		// Buttons (on standalone dialog)
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnSave', a2a.save);
		
		Buttons.addClickHandler('btnSelect', a2a.selectTo);
		Events.addEventHandler('btnSelect', 'base-selected', a2a.setLinkCallback);
		var frm = document.forms['anytoany'];
		
		if (frm.to_type.type == 'select-one')
		{
			var controllers = Items.getAllControllers();
			for (var itemType in controllers)
			{
				var controller = controllers[itemType];
				if (!controller.noAnyToAny)
				{
					frm.to_type[frm.to_type.length] = new Option(itemType, itemType);
				}
			}
		}
		
		// Tab validation
		TabControl.addTabValidator('settings.info', a2a.validateLink);
	}
	
	a2a.selectTo = function()
	{
		var frm = document.forms['anytoany'];
		var url;
		var id = Math.abs(parseInt(frm.to_id.value));				
		if (id > 0) 
		{
			var id = Math.abs(parseInt(frm.to_id.value));				
			url = '&item_id='+id;
		}
		Dialogs.selectItem(frm.to_type.value, 'btnSelect', 0, url);
	}
	
	a2a.setLinkCallback = function(event)
	{
		var id = event.detail.id;
		var name = event.detail.name;
		var frm = document.forms['anytoany'];
		frm.to_id.value = id;
		Doc.element('toName').innerHTML = Strings.encodeTags(name);
	}
	
	a2a.validateLink = function()
	{
		var frm = document.forms['anytoany'];
		if (Strings.trim(frm.name.value) == '')
		{
			Forms.showNotification(frm.name, 'You must enter a name');
			return false;
		}
		if (frm.to_id.value == '0')
		{
			Forms.showNotification('btnSelect', 'You must select a target item');
			return false;
		}
		if (frm.to_id.value == frm.from_id.value)
		{
			Forms.showNotification('btnSelect', 'Can\'t link an item to itself.');
			return false;
		}
		return true;
	}
	
	a2a.save = function()
	{
		var frm = document.forms['anytoany'];
		if (TabControl.validateActiveTab('settings'))
		{
			frm.submit();
		}
	}
	
	return a2a;
}();

Doc.onLoad(AnyToAny.initPage);