<%-- $Id: edit_platetype.jsp 6306 2013-08-13 13:15:33Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.PLATETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PlateType plateType = null;
	ItemResultList<PlateGeometry> plateGeometries = null;
	boolean readCurrentGeometry = true;
	PlateGeometry currentGeometry = null;
	int currentGeometryId = 0;

	if (itemId == 0)
	{
		title = "Create plate type";
		cc.removeObject("item");
		
		ItemQuery<PlateGeometry> geometryQuery = PlateGeometry.getQuery();
		geometryQuery.include(Include.ALL);
		geometryQuery.order(Orders.asc(Hql.property("name")));
		geometryQuery.setCacheResult(true);
		plateGeometries = geometryQuery.list(dc);
		currentGeometryId = Values.getInt(request.getParameter("plategeometry_id"));
		if (currentGeometryId == 0)
		{
			int recentGeometry = Values.getInt(cc.getRecent(Item.PLATEGEOMETRY.name(), 0), 0);
			currentGeometryId = Values.getInt(cc.getPropertyValue("plateGeometry"), recentGeometry);
		}
	}
	else
	{
		plateType = PlateType.getById(dc, itemId);
		plateType.checkPermission(Permission.WRITE);
		cc.setObject("item", plateType);
		title = "Edit plate type -- " + HTML.encodeTags(plateType.getName());
		try
		{
			currentGeometry = plateType.getPlateGeometry();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentGeometry = false;
		}
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), plateType);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~platetypes.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="platetype">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol" 
			position="bottom" remember="<%=plateType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Plate type" helpid="platetype.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=plateType == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(plateType == null ? Values.getString(cc.getPropertyValue("name"), "New plate type") : plateType.getName())%>" 
					maxlength="<%=PlateType.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Geometry</th>
				<td>
					<%
					if (plateType == null)
					{
						%>
						<select name="plategeometry_id" class="unchangeable">
						<%
						for (PlateGeometry pg : plateGeometries)
						{
							if (pg.isRemoved() && pg.getId() != currentGeometryId) continue;
							%>
							<option value="<%=pg.getId()%>" <%=pg.getId() == currentGeometryId ? "selected" : ""%>><%=HTML.encodeTags(pg.getName())%>
							<%
						}
						%>
						</select>
						<%
					}
					else
					{
						%>
						<%=Base.getEncodedName(currentGeometry, !readCurrentGeometry)%>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" name="description" id="description"
						><%=HTML.encodeTags(plateType == null ? cc.getPropertyValue("description") : plateType.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (plateType == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
