<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.SyncFilter"
	import="net.sf.basedb.core.SyncFilter.SourceItemTransform"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.listable.ListableUtil"
	import="net.sf.basedb.util.listable.SourceItemTransformerFactory"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static JSONArray toJSONArray(List<Item> items)
	{
		JSONArray json = new JSONArray();
		if (items != null)
		{
			for (Item i : items)
			{
				JSONObject jsonItem = new JSONObject();
				jsonItem.put("name", i.name());
				jsonItem.put("title", i.toString());
				json.add(jsonItem);
			}
		}
		return json;
	}
%>
<%
final Item itemType = Item.SYNCFILTER;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int listId = Values.getInt(request.getParameter("list_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ItemList list = ItemList.getById(dc, listId);
	list.checkPermission(Permission.WRITE);
	Item memberType = list.getMemberType();
	Item sourceItemType = memberType;
	SourceItemTransform sourceItemTransform = SourceItemTransform.NONE;
	boolean sourceMustExist = true;
	SyncFilter syncFilter = null;

	if (itemId == 0)
	{
		title = "Create synchronization filter";
		cc.removeObject("item");
		cc.setObject("item", list.newSyncFilter(dc));
	}
	else
	{
		syncFilter = SyncFilter.getById(dc, itemId);
		sourceItemType = syncFilter.getSourceItemType();
		sourceItemTransform = syncFilter.getSourceItemTransformation();
		sourceMustExist = syncFilter.getSourceItemMustExist();
		cc.setObject("item", syncFilter);
		dc.initCollection(syncFilter, "propertyFilters");
		title = "Edit synchronization filter -- " + HTML.encodeTags(syncFilter.getName());
	}
	
	SourceItemTransformerFactory factory = ListableUtil.getTransformerFactory(memberType);
	List<Item> allowedChildItems = factory != null ? factory.getSupportedSourceItems(SourceItemTransform.CHILD_TO_PARENT) : null;
	List<Item> allowedParentItems = factory != null ? factory.getSupportedSourceItems(SourceItemTransform.PARENT_TO_CHILD) : null;
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), syncFilter);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~syncfilter.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings"/></h1>

		<div id="page-data" class="datacontainer"
			data-list-member-type="<%=memberType.name()%>"
			data-source-item-type="<%=sourceItemType.name() %>"
			data-allowed-parent-items="<%=HTML.encodeTags(toJSONArray(allowedParentItems).toJSONString())%>"
			data-allowed-child-items="<%=HTML.encodeTags(toJSONArray(allowedChildItems).toJSONString())%>"
		></div>
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="syncfilter">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="list_id" value="<%=listId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=syncFilter != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Filter" helpid="syncfilter.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=syncFilter == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(syncFilter == null ? Values.getString(cc.getPropertyValue("name"), "New filter") : syncFilter.getName())%>" 
					maxlength="<%=SyncFilter.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th><label for="disabled">Disabled</label></th>
				<td>
					<input type="checkbox" name="disabled" id="disabled" <%=syncFilter != null && syncFilter.isDisabled() ? "checked" : "" %>>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Filter</th>
				<td colspan="2">
					
					<select name="sourceItemTransform" id="sourceItemTransform" style="width: 10em;">
						<option value="NONE" <%=sourceItemTransform == SourceItemTransform.NONE ? "selected" : ""%>><%=memberType %>
						<option value="PARENT_TO_CHILD" <%=sourceItemTransform == SourceItemTransform.PARENT_TO_CHILD ? "selected" : ""%>>Parent item
						<option value="CHILD_TO_PARENT" <%=sourceItemTransform == SourceItemTransform.CHILD_TO_PARENT ? "selected" : ""%>>Child item
					</select>
					<span id="none-transform">
						must match filter
					</span>
					<span id="parent-child-transform">
						of type
						<select name="sourceItemType" id="sourceItemType" style="width: 10em;">
						</select>
						that match filter
						<select name="sourceMustExist" id="sourceMustExist" style="width: 8em;">
							<option value="1" <%=sourceMustExist ? "selected" : "" %>>must exist
							<option value="0" <%=!sourceMustExist ? "selected" : "" %>>must not exist
						</select>
					</span>
				</td>
			</tr>
			<tr style="vertical-align: top;">
				<th class="subprompt"></th>
				<td>
					<pre class="messagecontainer note" id="filter-info" style="height: 12em; overflow: auto;"></pre>
				</td>
				<td>
					<base:icon id="btnModifyFilter" image="edit.png" tooltip="Modify the filter" style="margin-top: 40px;" />
				</td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(syncFilter == null ? cc.getPropertyValue("description") : syncFilter.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
